/*
  This program tests the ParsePrefix2AST and ParsePrefix2ParseTree parsers.

  After compiling this program, you can run it and create the
  png image files of the expression and parse trees with the
  following command line.

  > java.exe TestPrefix2 | dot.exe -Tpng -O

  This command line runs the Java program (in the Java Virtual
  Machine) and "pipes" the standard output of the Java program
  into the standard input of the dot.exe program, which then
  uses the input to create a png file for each of the trees.

  You can download the installer for dot.exe from this URL.
    http://www.graphviz.org/pub/graphviz/stable/windows/graphviz-2.28.0.msi
*/

public class TestPrefix2
{
   public static void main(String[] args)
   {
      String prefix[] =
            // prefix notation        // parenthesized infix notation
          { "+ 2 * 3 4",              // 2 + 3 * 4
            "* + 2 3 4",              // (2 + 3) * 4
            "+ - 2 3 4",              // 2 - 3 + 4
            "- 2 + 3 4",              // 2 - (3 + 4)
            "neg ^ 2 3",              // -2^3
            "^ neg 2 3",              // (-2)^3
            "/ + neg b sqrt - ^ b 2 * * 4 a c * 2 a"
          };


      for (int i = 0; i < prefix.length; i++)
      {
         BTree expTree  = ParsePrefix2AST.parsePrefix( prefix[i] );
         Tree parseTree = ParsePrefix2ParseTree.parsePrefix( prefix[i] );

         System.out.println("//  " + expTree + "\n");
         System.out.println( BTree2dot.btree2dot(expTree) + "\n" );
         System.out.println(  Tree2dot.tree2dot(parseTree) + "\n" );
      }
   }//main()

}//TestPrefix2
